VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Actions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements SmartTagLib.ISmartTagAction

Private Sub Class_Initialize()
On Error GoTo ErrorHandler
  'Initialize doesnt do anything, but we want to see
  'when this object is initialized in Instrumenter
  gLog.Log "Action Class Initialize"
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Sub

Private Sub Class_Terminate()
On Error GoTo ErrorHandler
  'Terminate doesnt do anything, but we want to see
  'when this object is Terminate in Instrumenter
  gLog.Log "Action Class Terminate"
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Sub

Private Property Get ISmartTagAction_Desc(ByVal LocaleID As Long) As String
On Error GoTo ErrorHandler
  'Description of this SmartTag
  gLog.Log "Action Description: " & gsST_Description
  ISmartTagAction_Desc = gsST_Description
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Sub ISmartTagAction_InvokeVerb(ByVal VerbID As Long, ByVal ApplicationName As String, ByVal Target As Object, ByVal Properties As SmartTagLib.ISmartTagProperties, ByVal Text As String, ByVal Xml As String)
On Error GoTo ErrorHandler
  'Actual code executed when user selects an action
  'from the smart tag in the host application
  gLog.Log "Action InvokeVerb:" & VerbID & " APP:" & ApplicationName & " TEXT:" & Text & " XML:" & Xml
  glST_SessionActionsInvoked = glST_SessionActionsInvoked + 1
  Select Case VerbID
    Case 100
      ACTION_IELaunchBrowser GenerateKBURL(Properties.Read("KBArticle"))
    Case 1000    'STINSTRUMENTMODE:  No Logging
      gLog.Mode = none
    Case 1001    'DebugWindow_VBONLY
       gLog.Mode = DebugWindow_VBONLY
    Case 1002    'OutputDebugString
       gLog.Mode = OutputDebugStringAPI
    Case 1003    'To File
       gLog.Mode = ToFile
    Case 1010    'Status DUmp
    SmartTagStatusDump
  End Select
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & "-" & Err.Description
  GoTo Finally
End Sub

Private Function GenerateKBURL(sKBA As String) As String
On Error GoTo ErrorHandler
  Dim sURL As String
  sURL = "http://support.microsoft.com/support/kb/articles/Q" 'Base URL
  'Format: NN/N/NN.ASP or NNN/N/NN.ASP
  If Len(sKBA) = 6 Then
    sURL = sURL & Mid(sKBA, 2, 2) & "/" & Mid(sKBA, 4, 1) & "/" & Right(sKBA, 2) & ".asp"
  Else
    sURL = sURL & Mid(sKBA, 2, 3) & "/" & Mid(sKBA, 5, 1) & "/" & Right(sKBA, 2) & ".asp"
  End If
  GenerateKBURL = sURL
Finally:
  Exit Function
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & "-" & Err.Description
  GoTo Finally
End Function

Private Property Get ISmartTagAction_Name(ByVal LocaleID As Long) As String
On Error Resume Next
  'Name of SmartTag
  gLog.Log "Action Name:" & gsST_Name
  ISmartTagAction_Name = gsST_Name
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagAction_ProgId() As String
On Error Resume Next
  'ProgID for action DLL (DLLName.ClassName)
  gLog.Log "Action ProgID: " & gsST_ProgIDActions
  ISmartTagAction_ProgId = gsST_ProgIDActions
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagAction_SmartTagCaption(ByVal SmartTagID As Long, ByVal LocaleID As Long) As String
On Error GoTo ErrorHandler
  'Appears at the top of the object UI as a Title for the menu
  gLog.Log "Action SmartTagCaption: " & gsST_TypesFriendlyNames(SmartTagID - 1)
  ISmartTagAction_SmartTagCaption = gsST_TypesFriendlyNames(SmartTagID - 1)
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagAction_SmartTagCount() As Long
On Error GoTo ErrorHandler
  'Count of SmartTags supported by this action dll
  gLog.Log "Action Count: " & giST_Count
  ISmartTagAction_SmartTagCount = giST_Count
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagAction_SmartTagName(ByVal SmartTagID As Long) As String
On Error Resume Next
  'Namespace for supported SmartTags
  gLog.Log "Action SmartTagName: " & gsST_Types(SmartTagID - 1)
  ISmartTagAction_SmartTagName = gsST_Types(SmartTagID - 1)
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagAction_VerbCaptionFromID(ByVal VerbID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long) As String
On Error GoTo ErrorHandler
  gLog.Log "Action VerbCaptionFromID: " & VerbID & " Application Name: " & ApplicationName
  Select Case VerbID
    Case 100    'Purchase Order
      ISmartTagAction_VerbCaptionFromID = "Look up this KB Article on the Internet"
    Case 1000    'STINSTRUMENTMODE:  No Logging
      ISmartTagAction_VerbCaptionFromID = "Log &Disabled"
    Case 1001    'DebugWindow_VBONLY
      ISmartTagAction_VerbCaptionFromID = "Log to Debug&Window (For VB Debugging ONLY)"
    Case 1002    'OutputDebugString
      ISmartTagAction_VerbCaptionFromID = "Log to &OutputDebugString()"
    Case 1003    'To File
      ISmartTagAction_VerbCaptionFromID = "Log to &File"
    Case 1010    'Status Dump
      ISmartTagAction_VerbCaptionFromID = "&Status Dump"
  End Select
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagAction_VerbCount(ByVal SmartTagName As String) As Long
On Error Resume Next
  'How many actions supported per Smart Tag
  'Type in this DLL
  gLog.Log "Action VerbCount for:" & SmartTagName
  Select Case SmartTagName
    Case gsST_Types(0)
      ISmartTagAction_VerbCount = 1 'KB Article lookup
    Case gsST_Types(1)
      ISmartTagAction_VerbCount = 5 'STINSTRUMENTMODE
    Case Else
      ISmartTagAction_VerbCount = 0
  End Select
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagAction_VerbID(ByVal SmartTagName As String, ByVal VerbIndex As Long) As Long
On Error GoTo ErrorHandler
  'Unique ID for each verb
  gLog.Log "Action VerbID for: " & SmartTagName & " VerbIndex: " & VerbIndex
  Select Case SmartTagName
    Case gsST_Types(0)      'KB Article lookup
      Select Case VerbIndex
        Case 1
          ISmartTagAction_VerbID = 100
      End Select
    Case gsST_Types(1)
      Select Case VerbIndex 'STINSTRUMENTMODE
        Case 1  'No Logging
          ISmartTagAction_VerbID = 1000
        Case 2  'DebugWindow_VBONLY
          ISmartTagAction_VerbID = 1001
        Case 3  'OutputDebugString
          ISmartTagAction_VerbID = 1002
        Case 4  'ToFile
          ISmartTagAction_VerbID = 1003
        Case 5  'StatusDump
          ISmartTagAction_VerbID = 1010
      End Select
    Case Else
      ISmartTagAction_VerbID = 0
  End Select
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagAction_VerbNameFromID(ByVal VerbID As Long) As String
On Error GoTo ErrorHandler
'Unique name for each verb
  gLog.Log "Action VerbNameFromID: " & VerbID
  Select Case VerbID
    Case 100
      ISmartTagAction_VerbNameFromID = "lookupthiskba"
    Case 1000    'STINSTRUMENTMODE:  No Logging
      ISmartTagAction_VerbNameFromID = "LogDisabled"
    Case 1001    'DebugWindow_VBONLY
      ISmartTagAction_VerbNameFromID = "DebugWindow_VBONLY"
    Case 1002    'OutputDebugString
      ISmartTagAction_VerbNameFromID = "LogToOutputDebugString"
    Case 1003    'To File
      ISmartTagAction_VerbNameFromID = "LogToFile"
    Case 1010    'Status Dump
      ISmartTagAction_VerbNameFromID = "LogStatusDump"
  End Select
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property


